<?php
class get_user extends CommonAction{

	/**
	 * 查询订单分布用户信息
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.0.1 + 2020.10.23
	 * @deprecated 暂不启用
	 * @global 无
	 * @param array $param 请求参数
	 * @param obj $_this 父级实例
	 * @return void
	*/
    public function run($param, $_this){
		if(empty($_SESSION['admin_id'])) return $_this->_json('01', '请先登录后台！');
		if($_SESSION['admin_id'] != 1 && !empty($_SESSION['region_id'])&&$all_region_status!=1){
			$arr = explode(',', $_SESSION['region_id']);
			if (in_array($_POST['city_id'], $arr) == false) return $_this->_json('01', '您暂无该地区预览权限！');
		}
		
		$where = $this->_where($param);
		$list = M('order')->alias('A')
				->join('inner join hd_order_kilometers AS B ON A.id=B.order_id')
				->where($where)
				->field('A.id, A.order_sn, A.user_phone, A.original, A.destination, A.begion_time, B.s_lat, B.s_long')
				->order('A.id ASC')
				->select();

		$list = $this->_switch1($list);
		$list = $this->_switch2($list);
		return $_this->_json('00', '获取成功！', $list);
	}
	// 客户对应单量统计
	private function _switch1($list) {
		$array = array();
		foreach ($list as $v) {
			$array[$v['user_phone']][] = $v;
		}
		return $array;
	}
	// 客户下单情况检测
	private function _switch2($list) {
		// 条件组装
		$top = array();
		$bottom = array();
		foreach ($list as $user_phone=>$v) {
			
			$data = array(
				'user_phone' => $user_phone,
				'count' => count($v),
			);
			if ($data['count'] == 1) {
				$data['avg'] = 1;
			} else {
				$data['avg'] = ceil(31/$data['count']); // 平均下单天数
			}
			foreach ($v as $val) {
				$data['id'] = $val['id'];
				$data['order_sn'] = $val['order_sn'];
				$data['s_lat'] = $val['s_lat'];
				$data['s_long'] = $val['s_long'];
				$data['original'] = $val['original'];
				$data['destination'] = $val['destination'];
				$data['begion_time'] = date('Y-m-d H:i:s', $val['begion_time']);
			}
			// 计算是否潜在客户
			$day = ceil((time()-strtotime($data['begion_time'])) / 86400);
			if ($day == 32) $day = 31;
			$data['last_hole'] = $day;
			$data['is_potential'] = 2;
			if ($data['avg'] >= 2 && $data['last_hole'] >= $data['avg']) {
				$data['is_potential'] = 1;
			}
			if ($data['is_potential'] == 1) {
				$top[] = $data;
			} else {
				// $bottom[] = $data;
			}
		}
		// 排序，潜在客户在前面
		// foreach ($bottom as $v) {
		// 	$top[] = $v;
		// }
		return $top;
	}

	private function _where($param) {
		// 只看31天内的订单分布
		$time = strtotime(date('Y-m-d', time()))-(86400*31);
		$where  = 'A.status=1';
		$where .= ' AND A.regions_id='.$param['city_id'];
		$where .= ' AND A.begion_time >= '.$time;
		$where .= ' AND A.begion_time < '.time();
		return $where;
	}
}